zoukankan      html  css  js  c++  java
  • Codeforces Round #272 (Div. 2) Dreamoon and WiFi 暴力

    B. Dreamoon and WiFi

    Dreamoon is standing at the position 0 on a number line. Drazil is sending a list of commands through Wi-Fi to Dreamoon's smartphone and Dreamoon follows them.

    Each command is one of the following two types:

    1. Go 1 unit towards the positive direction, denoted as '+'
    2. Go 1 unit towards the negative direction, denoted as '-'

    But the Wi-Fi condition is so poor that Dreamoon's smartphone reports some of the commands can't be recognized and Dreamoon knows that some of them might even be wrong though successfully recognized. Dreamoon decides to follow every recognized command and toss a fair coin to decide those unrecognized ones (that means, he moves to the 1 unit to the negative or positive direction with the same probability 0.5).

    You are given an original list of commands sent by Drazil and list received by Dreamoon. What is the probability that Dreamoon ends in the position originally supposed to be final by Drazil's commands?

    Input

    The first line contains a string s1 — the commands Drazil sends to Dreamoon, this string consists of only the characters in the set {'+','-'}.

    The second line contains a string s2 — the commands Dreamoon's smartphone recognizes, this string consists of only the characters in the set {'+', '-', '?'}. '?' denotes an unrecognized command.

    Lengths of two strings are equal and do not exceed 10.

    Output

    Output a single real number corresponding to the probability. The answer will be considered correct if its relative or absolute error doesn't exceed 10 - 9.

    Sample test(s)
    input
    ++-+-
    +-+-+
    output
    1.000000000000
     
    Note

    For the first sample, both s1 and s2 will lead Dreamoon to finish at the same position  + 1.

    For the second sample, s1 will lead Dreamoon to finish at position 0, while there are four possibilites for s2: {"+-++", "+-+-", "+--+", "+---"} with ending position {+2, 0, 0, -2} respectively. So there are 2 correct cases out of 4, so the probability of finishing at the correct position is 0.5.

    For the third sample, s2 could only lead us to finish at positions {+1, -1, -3}, so the probability to finish at the correct position  + 3 is 0.

    题意:给你两个只含+-的字符串,表示+1,-1

           第二串含有?   可能是+或-   现在问你第二串等于第一串的值得 概率是多少.

    题解:对于没有?,直接判

            有?  我们就暴力出多少种情况就好了   字符长度小于11,妥妥的暴力

    ///1085422276
    #include<bits/stdc++.h>
    using namespace std ;
    typedef long long ll;
    #define mem(a) memset(a,0,sizeof(a))
    #define meminf(a) memset(a,127,sizeof(a));
    #define TS printf("111111
    ");
    #define FOR(i,a,b) for( int i=a;i<=b;i++)
    #define FORJ(i,a,b) for(int i=a;i>=b;i--)
    #define READ(a,b,c) scanf("%d%d%d",&a,&b,&c)
    #define inf 100000000
    inline ll read()
    {
        ll x=0,f=1;
        char ch=getchar();
        while(ch<'0'||ch>'9')
        {
            if(ch=='-')f=-1;
            ch=getchar();
        }
        while(ch>='0'&&ch<='9')
        {
            x=x*10+ch-'0';
            ch=getchar();
        }
        return x*f;
    }
    //****************************************
    #define maxn 10000+5
    int aa[maxn],H[maxn];
    char a[maxn],b[maxn];
    void dfs(int x,int s){
    
      if(x==0){
          H[s+15]++;
          return ;
      }
       dfs(x-1,s+1);
       dfs(x-1,s-1);
    }
    int main(){
       int ans=0;
        scanf("%s%s",a,b);
        int lena=strlen(a);
        int  lenb=strlen(b);
        for(int i=0;i<lena;i++){
            if(a[i]=='+')ans++;
                else ans--;
        }
        int tmp=0;
        int bb=0;
        for(int i=0;i<lenb;i++){
            if(b[i]=='+')tmp++;
                else if(b[i]=='-')tmp--;
                else bb++;
        }double anss;mem(H);
        if(bb==0){
            if(tmp==ans){
                anss=1.0;
            }
            else anss=0;
        }
        else {
            dfs(bb,tmp);
            int sum=1;
          for(int i=1;i<=bb;i++)sum*=2;
        anss=H[ans+15]*1.0/sum*1.0;
        }
    
        printf("%.12f
    ",anss);
      return 0;
    }
    代码
  • 相关阅读:
    性能测试系列(1)-性能测试基本概念
    性能篇综合汇总
    【CTFHUB】Web技能树
    Flash XSS
    绕过CDN找到⽬标站点真实IP
    【网鼎杯2020白虎组】Web WriteUp [picdown]
    【网鼎杯2020朱雀组】Web WriteUp
    【网鼎杯2020青龙组】Web WriteUp
    利用DNSLog实现无回显注入
    Cobalt Stike使用教程
  • 原文地址:https://www.cnblogs.com/zxhl/p/4930390.html
Copyright © 2011-2022 走看看